/**********************************************************************************************/
/* FBL_Deleter.h																			  */
/*                                                                       					  */
/* Foundation Base Library ( FBL )		                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002                                        					  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/

#ifndef __FBL_Deleter_h 
	#define __FBL_Deleter_h

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
template <class T> class FBL_Deleter
{ 	
    public://///////////////////////////////////////////////////////////////////////////////////
		
					FBL_Deleter( T*& aWatched ) :
						watched( aWatched )
					{
						owns = true;
					}
					
virtual				~FBL_Deleter( void )
					{
						if( owns && watched ) {
							delete watched;
							watched = NULL;
						}
					}
				
		T*			Release( void ) {
						owns = false;
						return watched;
					}
		
		
    protected://////////////////////////////////////////////////////////////////////////////////

		T*&			watched;
		bool		owns;
};


/**********************************************************************************************/
template <class T> class FBL_ValueChanger
{
	public:

		FBL_ValueChanger( T& inVariable, T inNewValue ) :
			mVariable(inVariable)
		{
			mPrevValue	= mVariable;
			mVariable	= inNewValue;
		}

		~FBL_ValueChanger( void ) {
			mVariable = mPrevValue;
		}

	protected:

		T&	mVariable;	
		T	mPrevValue;

};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif	// __FBL_Deleter_h

