/**********************************************************************************************/
/* FBL_MaxFormula.h																			  */
/*                                                                       					  */
/* Foundation Base Library ( FBL )		                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002                                       					  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/

#ifndef __FBL_MaxFormula_h
   #define __FBL_MaxFormula_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL_Formula.h>
#else
#	include <FBL_Formula.h>
#endif // VSDK_FRAMEWORK_STYLE


#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_MaxFormula : public FBL_ConstFormula
{
		// must be applied to numeric fields only.

	public://///////////////////////////////////////////////////////////////////////////////////
	
FBL_EXP							FBL_MaxFormula( uchar inFieldType );
							
FBL_EXP virtual bool			DoFormula( 
									FBL_REC_ID	inRecID,
									const void* inFieldValue,
									bool		inIsNull );
					
		double					GetResult( void ) const { return mMax; }			
						
	protected:////////////////////////////////////////////////////////////////////////////////// 

								// Makes first assigment to the mMax; 
FBL_EXP	void					Init( const void* inFieldValue );

	protected:////////////////////////////////////////////////////////////////////////////////// 

		uchar					mFieldType;
		double					mMax;
		bool					mNotInited;		// true if the mMax is not inited yet.				
};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif
