/**********************************************************************************************/
/* FBL_PathUtilities.h	                                                   					  */
/*                                                                       					  */
/* Foundation Base Library ( FBL )		                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002                                       					  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/

#ifndef __FBL_PathUtilities_h 
	#define __FBL_PathUtilities_h

#include "FBL.h"

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
#ifdef FBL_MAC
	OSErr 					FBL_Path2Spec( 
								const char*		fullPath, 
								FSSpec*			spec );

	OSErr 					FBL_FSMakePath(
								SInt16 			volRefNum,
								SInt32 			dirID,
								ConstStr255Param name,
								char*			path,
								ulong 			maxPathSize );
#endif


/**********************************************************************************************/
// Exctract from a full path name of file. For each platform this function uses its delimiter.
//
char*	ExtractNameFromFullPath( const char* inFullPath );


/**********************************************************************************************/
void MakePathInTheSameFolder( 
		FILE_PATH* 	inOtherFile, 	// file wich we want to use to get folder. Usually a db file.
		FILE_PATH* 	outPath, 		// new path
		char* 		inFileName );	// new name for that path




/**********************************************************************************************/
// ==== MoreFiles code ====
//

#ifdef FBL_MAC

OSErr 				FBL_GetCatInfoNoName( 
						short vRefNum, 
						long dirID, 
						ConstStr255Param name, 
						CInfoPBPtr pb);

OSErr 				FBL_GetDirectoryID(
						short vRefNum,
						long dirID,
						ConstStr255Param name,
						long *theDirID,
						bool *isDirectory);

OSErr 				FBL_FSpGetFullPath(
						const FSSpec *spec,
						short *fullPathLength,
						Handle *fullPath );

OSErr 				FBL_CheckObjectLock( 
						short vRefNum, 
						long dirID, 
						ConstStr255Param name );
						
OSErr 				FBL_FSpCheckObjectLock( 
						const FSSpec *spec );

#ifdef __MACH__

OSErr 				FBL_FSMakeFSRef(
						FSVolumeRefNum volRefNum,
						SInt32 dirID,
						ConstStr255Param name,
						FSRef *ref);

#endif // __MACH__

#endif // FBL_MAC


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif	// __FBL_PathUtilities_h
