/**********************************************************************************************/
/* OBL_Exceptions.h																			  */
/*                                                                       					  */
/* Object Base Library ( OBL )			                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002                                        					  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/

#ifndef __OBL_Exceptions_h 
	#define __OBL_Exceptions_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL_Exceptions.h>
#else
#	include <FBL_Exceptions.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
enum OBL_Errors
{	
	kOBL_Error					= 500,		

	kOBL_BaseObjectError		= 501,
	kOBL_RelationError			= 502,
	kOBL_DataBaseError			= 503,
	
						// DataBase errors:
	kOBL_WrongDBName			= 510,		
	
						// BaseObject errors.
									
	kOBL_WrongBaseNumber		= 520,		
	kOBL_WrongChildType			= 521,
	kOBL_ObjectIsNotEmpty		= 522,	// Object is not empty.
	kOBL_CorruptedChain			= 523,	// corupted relations beetwen ObjectTables of BaseObject.
										// Can be thrown on Deleting BaseObject.
	
	kOBL_ExpectedBONotFound		= 524,
	kOBL_ExpectedFieldNotFound	= 525,

						// Relation errors.
									
	kFBL_RESTRICTRelate			= 550,				
	kOBL_RelationIsNotEmpty		= 551	// Relation is not empty.
	
						// SQL Parser error:
						
	// this errors start from 600					 

};


/**********************************************************************************************/
DECLARE_EXCEPTION( xOBL_Exception		, xFBL_Exception 		, kOBL_Error	)


/**********************************************************************************************/
DECLARE_EXCEPTION( xOBL_BaseObjectError		, xOBL_Exception 		, kOBL_BaseObjectError	)
DECLARE_EXCEPTION( xOBL_RelationError		, xOBL_Exception 		, kOBL_RelationError	)
DECLARE_EXCEPTION( xOBL_DataBaseError		, xOBL_Exception 		, kOBL_DataBaseError	)


/**********************************************************************************************/
class xOBL_ParserError : public xOBL_Exception 									
{																	 															
	public:	
		ulong mPos;	// position in the string where is an error.
														
		xOBL_ParserError( long err, ulong inPos ) : xOBL_Exception(err) { mPos = inPos; }
};


/**********************************************************************************************/
DECLARE_EXCEPTION( xOBL_WrongDBName			, xOBL_DataBaseError 	, kOBL_WrongDBName	)	

/**********************************************************************************************/
DECLARE_EXCEPTION( xOBL_WrongBaseNumber			, xOBL_BaseObjectError 	, kOBL_WrongBaseNumber	)	
DECLARE_EXCEPTION( xOBL_WrongChildType			, xOBL_BaseObjectError 	, kOBL_WrongChildType	)	
DECLARE_EXCEPTION( xOBL_ObjectIsNotEmpty		, xOBL_BaseObjectError 	, kOBL_ObjectIsNotEmpty	)	
DECLARE_EXCEPTION( xOBL_CorruptedChain			, xOBL_BaseObjectError 	, kOBL_CorruptedChain	)	
DECLARE_EXCEPTION( xOBL_ExpectedBONotFound		, xOBL_BaseObjectError 	, kOBL_ExpectedBONotFound )	
DECLARE_EXCEPTION( xOBL_ExpectedFieldNotFound	, xOBL_BaseObjectError 	, kOBL_ExpectedFieldNotFound)	


/**********************************************************************************************/
DECLARE_EXCEPTION( xFBL_RESTRICTRelate			, xOBL_RelationError 	, kFBL_RESTRICTRelate	)	
DECLARE_EXCEPTION( xOBL_RelationIsNotEmpty		, xOBL_RelationError	, kOBL_RelationIsNotEmpty)	


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif	// __OBL_Exceptions_h
